
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Material_allocationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_allocations = await db.material_allocations.create(
            {
                id: data.id || undefined,
        
        required_qty: data.required_qty
        ||
        null
            ,
            
        issued_qty: data.issued_qty
        ||
        null
            ,
            
        uom: data.uom
        ||
        null
            ,
            
        issue_status: data.issue_status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await material_allocations.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await material_allocations.setComponent_material( data.component_material || null, {
            transaction,
        });
        
        await material_allocations.setLot( data.lot || null, {
            transaction,
        });
        
        await material_allocations.setFrom_location( data.from_location || null, {
            transaction,
        });
        
        await material_allocations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return material_allocations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const material_allocationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                required_qty: item.required_qty
            ||
            null
            ,
            
                issued_qty: item.issued_qty
            ||
            null
            ,
            
                uom: item.uom
            ||
            null
            ,
            
                issue_status: item.issue_status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const material_allocations = await db.material_allocations.bulkCreate(material_allocationsData, { transaction });

        // For each item created, replace relation files
        

        return material_allocations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const material_allocations = await db.material_allocations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.required_qty !== undefined) updatePayload.required_qty = data.required_qty;
        
        
        if (data.issued_qty !== undefined) updatePayload.issued_qty = data.issued_qty;
        
        
        if (data.uom !== undefined) updatePayload.uom = data.uom;
        
        
        if (data.issue_status !== undefined) updatePayload.issue_status = data.issue_status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await material_allocations.update(updatePayload, {transaction});

        
        
        if (data.production_order !== undefined) {
            await material_allocations.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.component_material !== undefined) {
            await material_allocations.setComponent_material(
              
              data.component_material,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await material_allocations.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.from_location !== undefined) {
            await material_allocations.setFrom_location(
              
              data.from_location,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await material_allocations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return material_allocations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const material_allocations = await db.material_allocations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of material_allocations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of material_allocations) {
                await record.destroy({transaction});
            }
        });


        return material_allocations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const material_allocations = await db.material_allocations.findByPk(id, options);

        await material_allocations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await material_allocations.destroy({
            transaction
        });

        return material_allocations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const material_allocations = await db.material_allocations.findOne(
            { where },
            { transaction },
        );

        if (!material_allocations) {
            return material_allocations;
        }

        const output = material_allocations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.production_order = await material_allocations.getProduction_order({
            transaction
        });
        
        
        output.component_material = await material_allocations.getComponent_material({
            transaction
        });
        
        
        output.lot = await material_allocations.getLot({
            transaction
        });
        
        
        output.from_location = await material_allocations.getFrom_location({
            transaction
        });
        
        
        output.organizations = await material_allocations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.materials,
        as: 'component_material',
        
        where: filter.component_material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.component_material.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.component_material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'from_location',
        
        where: filter.from_location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.from_location.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.from_location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.uom) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'material_allocations',
                        'uom',
                        filter.uom,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'material_allocations',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.required_qtyRange) {
                const [start, end] = filter.required_qtyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    required_qty: {
                    ...where.required_qty,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    required_qty: {
                    ...where.required_qty,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.issued_qtyRange) {
                const [start, end] = filter.issued_qtyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    issued_qty: {
                    ...where.issued_qty,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    issued_qty: {
                    ...where.issued_qty,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.issue_status) {
                where = {
                    ...where,
                issue_status: filter.issue_status,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.material_allocations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'material_allocations',
                        'uom',
                        query,
                    ),
                ],
            };
        }

        const records = await db.material_allocations.findAll({
            attributes: [ 'id', 'uom' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['uom', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.uom,
        }));
    }

    
};

